import java.util.Calendar;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.midlet.MIDlet;

public class TemplateMIDlet extends MIDlet implements Runnable {
	
	Thread thread;
	
	Image offi;
	Canvas canvas;
	
	int COLOR_BLACK = 0x000000;
	int COLOR_WHITE = 0xFFFFFF;
	
	public TemplateMIDlet() {
		canvas = new Canvas() {
			public void paint(Graphics g) {
				g.drawImage(offi, 0, 0, Graphics.TOP | Graphics.LEFT);
			}
			
			protected void keyPressed(int keyCode) {
				if (Display.getDisplay(TemplateMIDlet.this).getCurrent() == this) {
					Display.getDisplay(TemplateMIDlet.this).setCurrent(new Alert("Information", "button has been pushed", null, AlertType.INFO), this);
				}
			}
		};
		offi = Image.createImage(canvas.getWidth(), canvas.getHeight());
		Display.getDisplay(this).setCurrent(canvas);
	}
	
	protected void startApp() {
		if (thread == null) {
			thread = new Thread(this);
			thread.start();
		}
	}
	
	protected void pauseApp() {
		// ̃Cxg͗pȂ̂ŎKv͂Ȃ
	}
	
	protected void destroyApp(boolean unconditional) {
		// ̃Cxg͗pȂ̂ŎKv͂Ȃ
	}
	
	void drawAll(Graphics g) {
		Calendar calendar = Calendar.getInstance();
		String time = calendar.get(Calendar.HOUR_OF_DAY)+ ":";
		time += calendar.get(Calendar.MINUTE)+ ":";
		time += calendar.get(Calendar.SECOND);
		g.setColor(COLOR_WHITE);
		g.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
		g.setColor(COLOR_BLACK);
		g.drawString(time, 0, 0, Graphics.TOP | Graphics.LEFT);
	}
	
	public void run() {
		Graphics g = offi.getGraphics();
		while (true) {
			drawAll(g);
			canvas.repaint();
			canvas.serviceRepaints();
			sleep(100);
		}
	}
	
	void sleep(long millis) {
		try {
			Thread.sleep(millis);
		} catch (InterruptedException e) {
			// O͔Ȃ
		}
	}
	
}
